<?php

/* ***********************************************************
 * This file was automatically generated on 2017-04-21.      *
 *                                                           *
 * PHP Bindings Version 2.1.12                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Communicates with RS232 devices
 */
class BrickletRS232 extends Device
{

    /**
     * This callback is called if new data is available. The message has
     * a maximum size of 60 characters. The actual length of the message
     * is given in addition.
     * 
     * To enable this callback, use BrickletRS232::enableReadCallback().
     */
    const CALLBACK_READ = 8;

    /**
     * This callback is called if an error occurs.
     * Possible errors are overrun, parity or framing error.
     * 
     * .. versionadded:: 2.0.1$nbsp;(Plugin)
     */
    const CALLBACK_ERROR = 9;

    /**
     * This callback is called if new data is available. The message has
     * a maximum size of 60 characters. The actual length of the message
     * is given in addition.
     *
     * To enable this callback, use BrickletRS232::enableReadCallback().
     */
    const CALLBACK_READ_CALLBACK = self::CALLBACK_READ; // for backward compatibility

    /**
     * This callback is called if an error occurs.
     * Possible errors are overrun, parity or framing error.
     *
     * .. versionadded:: 2.0.1$nbsp;(Plugin)
     */
    const CALLBACK_ERROR_CALLBACK = self::CALLBACK_ERROR; // for backward compatibility


    /**
     * @internal
     */
    const FUNCTION_WRITE = 1;

    /**
     * @internal
     */
    const FUNCTION_READ = 2;

    /**
     * @internal
     */
    const FUNCTION_ENABLE_READ_CALLBACK = 3;

    /**
     * @internal
     */
    const FUNCTION_DISABLE_READ_CALLBACK = 4;

    /**
     * @internal
     */
    const FUNCTION_IS_READ_CALLBACK_ENABLED = 5;

    /**
     * @internal
     */
    const FUNCTION_SET_CONFIGURATION = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_CONFIGURATION = 7;

    /**
     * @internal
     */
    const FUNCTION_SET_BREAK_CONDITION = 10;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const BAUDRATE_300 = 0;
    const BAUDRATE_600 = 1;
    const BAUDRATE_1200 = 2;
    const BAUDRATE_2400 = 3;
    const BAUDRATE_4800 = 4;
    const BAUDRATE_9600 = 5;
    const BAUDRATE_14400 = 6;
    const BAUDRATE_19200 = 7;
    const BAUDRATE_28800 = 8;
    const BAUDRATE_38400 = 9;
    const BAUDRATE_57600 = 10;
    const BAUDRATE_115200 = 11;
    const BAUDRATE_230400 = 12;
    const PARITY_NONE = 0;
    const PARITY_ODD = 1;
    const PARITY_EVEN = 2;
    const PARITY_FORCED_PARITY_1 = 3;
    const PARITY_FORCED_PARITY_0 = 4;
    const STOPBITS_1 = 1;
    const STOPBITS_2 = 2;
    const WORDLENGTH_5 = 5;
    const WORDLENGTH_6 = 6;
    const WORDLENGTH_7 = 7;
    const WORDLENGTH_8 = 8;
    const HARDWARE_FLOWCONTROL_OFF = 0;
    const HARDWARE_FLOWCONTROL_ON = 1;
    const SOFTWARE_FLOWCONTROL_OFF = 0;
    const SOFTWARE_FLOWCONTROL_ON = 1;
    const ERROR_OVERRUN = 1;
    const ERROR_PARITY = 2;
    const ERROR_FRAMING = 4;

    const DEVICE_IDENTIFIER = 254;

    const DEVICE_DISPLAY_NAME = "RS232 Bricklet";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 2);

        $this->responseExpected[self::FUNCTION_WRITE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_READ] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_ENABLE_READ_CALLBACK] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_DISABLE_READ_CALLBACK] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_IS_READ_CALLBACK_ENABLED] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_READ] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_ERROR] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_SET_BREAK_CONDITION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_READ] = 'callbackWrapperRead';
        $this->callbackWrappers[self::CALLBACK_ERROR] = 'callbackWrapperError';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Writes a string of up to 60 characters to the RS232 interface. The string
     * can be binary data, ASCII or similar is not necessary.
     * 
     * The length of the string has to be given as an additional parameter.
     * 
     * The return value is the number of bytes that could be written.
     * 
     * See BrickletRS232::setConfiguration() for configuration possibilities
     * regarding baudrate, parity and so on.
     * 
     * @param string[] $message
     * @param int $length
     * 
     * @return int
     */
    public function write($message, $length)
    {
        $payload = '';
        for ($i = 0; $i < count($message) && $i < 60; $i++) {
            $payload .= pack('c', ord($message[$i]));
        }
        for ($i = count($message); $i < 60; $i++) {
            $payload .= pack('c', 0);
        }
        $payload .= pack('C', $length);

        $data = $this->sendRequest(self::FUNCTION_WRITE, $payload);

        $payload = unpack('C1written', $data);

        return $payload['written'];
    }

    /**
     * Returns the currently buffered message. The maximum length
     * of message is 60. If the length is given as 0, there was no
     * new data available.
     * 
     * Instead of polling with this function, you can also use
     * callbacks. See BrickletRS232::enableReadCallback() and BrickletRS232::CALLBACK_READ callback.
     * 
     * 
     * @return array
     */
    public function read()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_READ, $payload);

        $payload = unpack('c60message/C1length', $data);

        $result['message'] = IPConnection::collectUnpackedCharArray($payload, 'message', 60);
        $result['length'] = $payload['length'];

        return $result;
    }

    /**
     * Enables the BrickletRS232::CALLBACK_READ callback.
     * 
     * By default the callback is disabled.
     * 
     * 
     * @return void
     */
    public function enableReadCallback()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_ENABLE_READ_CALLBACK, $payload);
    }

    /**
     * Disables the BrickletRS232::CALLBACK_READ callback.
     * 
     * By default the callback is disabled.
     * 
     * 
     * @return void
     */
    public function disableReadCallback()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DISABLE_READ_CALLBACK, $payload);
    }

    /**
     * Returns *true* if the BrickletRS232::CALLBACK_READ callback is enabled,
     * *false* otherwise.
     * 
     * 
     * @return bool
     */
    public function isReadCallbackEnabled()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_IS_READ_CALLBACK_ENABLED, $payload);

        $payload = unpack('C1enabled', $data);

        return (bool)$payload['enabled'];
    }

    /**
     * Sets the configuration for the RS232 communication. Available options:
     * 
     * * Baudrate between 300 and 230400 baud.
     * * Parity of none, odd, even or forced parity.
     * * Stopbits can be 1 or 2.
     * * Word length of 5 to 8.
     * * Hard-/Software flow control can each be on or off.
     * 
     * The default is: 115200 baud, parity none, 1 stop bit, word length 8, hard-/software flow control off.
     * 
     * @param int $baudrate
     * @param int $parity
     * @param int $stopbits
     * @param int $wordlength
     * @param int $hardware_flowcontrol
     * @param int $software_flowcontrol
     * 
     * @return void
     */
    public function setConfiguration($baudrate, $parity, $stopbits, $wordlength, $hardware_flowcontrol, $software_flowcontrol)
    {
        $payload = '';
        $payload .= pack('C', $baudrate);
        $payload .= pack('C', $parity);
        $payload .= pack('C', $stopbits);
        $payload .= pack('C', $wordlength);
        $payload .= pack('C', $hardware_flowcontrol);
        $payload .= pack('C', $software_flowcontrol);

        $this->sendRequest(self::FUNCTION_SET_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickletRS232::setConfiguration().
     * 
     * 
     * @return array
     */
    public function getConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CONFIGURATION, $payload);

        $payload = unpack('C1baudrate/C1parity/C1stopbits/C1wordlength/C1hardware_flowcontrol/C1software_flowcontrol', $data);

        $result['baudrate'] = $payload['baudrate'];
        $result['parity'] = $payload['parity'];
        $result['stopbits'] = $payload['stopbits'];
        $result['wordlength'] = $payload['wordlength'];
        $result['hardware_flowcontrol'] = $payload['hardware_flowcontrol'];
        $result['software_flowcontrol'] = $payload['software_flowcontrol'];

        return $result;
    }

    /**
     * Sets a break condition (the TX output is forced to a logic 0 state).
     * The parameter sets the hold-time of the break condition (in ms).
     * 
     * .. versionadded:: 2.0.2$nbsp;(Plugin)
     * 
     * @param int $break_time
     * 
     * @return void
     */
    public function setBreakCondition($break_time)
    {
        $payload = '';
        $payload .= pack('v', $break_time);

        $this->sendRequest(self::FUNCTION_SET_BREAK_CONDITION, $payload);
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to,
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperRead($data)
    {
        $result = array();
        $payload = unpack('c60message/C1length', $data);

        array_push($result, IPConnection::collectUnpackedCharArray($payload, 'message', 60));
        array_push($result, $payload['length']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_READ]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_READ], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperError($data)
    {
        $result = array();
        $payload = unpack('C1error', $data);

        array_push($result, $payload['error']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ERROR]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ERROR], $result);
    }
}

?>
