<?php

/* ***********************************************************
 * This file was automatically generated on 2017-04-21.      *
 *                                                           *
 * PHP Bindings Version 2.1.12                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Silently drives one bipolar stepper motor with up to 46V and 1.6A per phase
 */
class BrickSilentStepper extends Device
{

    /**
     * This callback is triggered when the input voltage drops below the value set by
     * BrickSilentStepper::setMinimumVoltage(). The parameter is the current voltage given
     * in mV.
     */
    const CALLBACK_UNDER_VOLTAGE = 40;

    /**
     * This callback is triggered when a position set by BrickSilentStepper::setSteps() or
     * BrickSilentStepper::setTargetPosition() is reached.
     * 
     * <note>
     *  Since we can't get any feedback from the stepper motor, this only works if the
     *  acceleration (see BrickSilentStepper::setSpeedRamping()) is set smaller or equal to the
     *  maximum acceleration of the motor. Otherwise the motor will lag behind the
     *  control value and the callback will be triggered too early.
     * </note>
     */
    const CALLBACK_POSITION_REACHED = 41;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickSilentStepper::setAllDataPeriod(). The parameters are: the current velocity,
     * the current position, the remaining steps, the stack voltage, the external
     * voltage and the current consumption of the stepper motor.
     */
    const CALLBACK_ALL_DATA = 47;

    /**
     * This callback is triggered whenever the Slient Stepper Brick enters a new state.
     * It returns the new state as well as the previous state.
     */
    const CALLBACK_NEW_STATE = 48;


    /**
     * @internal
     */
    const FUNCTION_SET_MAX_VELOCITY = 1;

    /**
     * @internal
     */
    const FUNCTION_GET_MAX_VELOCITY = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_CURRENT_VELOCITY = 3;

    /**
     * @internal
     */
    const FUNCTION_SET_SPEED_RAMPING = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_SPEED_RAMPING = 5;

    /**
     * @internal
     */
    const FUNCTION_FULL_BRAKE = 6;

    /**
     * @internal
     */
    const FUNCTION_SET_CURRENT_POSITION = 7;

    /**
     * @internal
     */
    const FUNCTION_GET_CURRENT_POSITION = 8;

    /**
     * @internal
     */
    const FUNCTION_SET_TARGET_POSITION = 9;

    /**
     * @internal
     */
    const FUNCTION_GET_TARGET_POSITION = 10;

    /**
     * @internal
     */
    const FUNCTION_SET_STEPS = 11;

    /**
     * @internal
     */
    const FUNCTION_GET_STEPS = 12;

    /**
     * @internal
     */
    const FUNCTION_GET_REMAINING_STEPS = 13;

    /**
     * @internal
     */
    const FUNCTION_SET_STEP_CONFIGURATION = 14;

    /**
     * @internal
     */
    const FUNCTION_GET_STEP_CONFIGURATION = 15;

    /**
     * @internal
     */
    const FUNCTION_DRIVE_FORWARD = 16;

    /**
     * @internal
     */
    const FUNCTION_DRIVE_BACKWARD = 17;

    /**
     * @internal
     */
    const FUNCTION_STOP = 18;

    /**
     * @internal
     */
    const FUNCTION_GET_STACK_INPUT_VOLTAGE = 19;

    /**
     * @internal
     */
    const FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = 20;

    /**
     * @internal
     */
    const FUNCTION_GET_CURRENT_CONSUMPTION = 21;

    /**
     * @internal
     */
    const FUNCTION_SET_MOTOR_CURRENT = 22;

    /**
     * @internal
     */
    const FUNCTION_GET_MOTOR_CURRENT = 23;

    /**
     * @internal
     */
    const FUNCTION_ENABLE = 24;

    /**
     * @internal
     */
    const FUNCTION_DISABLE = 25;

    /**
     * @internal
     */
    const FUNCTION_IS_ENABLED = 26;

    /**
     * @internal
     */
    const FUNCTION_SET_BASIC_CONFIGURATION = 27;

    /**
     * @internal
     */
    const FUNCTION_GET_BASIC_CONFIGURATION = 28;

    /**
     * @internal
     */
    const FUNCTION_SET_SPREADCYCLE_CONFIGURATION = 29;

    /**
     * @internal
     */
    const FUNCTION_GET_SPREADCYCLE_CONFIGURATION = 30;

    /**
     * @internal
     */
    const FUNCTION_SET_STEALTH_CONFIGURATION = 31;

    /**
     * @internal
     */
    const FUNCTION_GET_STEALTH_CONFIGURATION = 32;

    /**
     * @internal
     */
    const FUNCTION_SET_COOLSTEP_CONFIGURATION = 33;

    /**
     * @internal
     */
    const FUNCTION_GET_COOLSTEP_CONFIGURATION = 34;

    /**
     * @internal
     */
    const FUNCTION_SET_MISC_CONFIGURATION = 35;

    /**
     * @internal
     */
    const FUNCTION_GET_MISC_CONFIGURATION = 36;

    /**
     * @internal
     */
    const FUNCTION_GET_DRIVER_STATUS = 37;

    /**
     * @internal
     */
    const FUNCTION_SET_MINIMUM_VOLTAGE = 38;

    /**
     * @internal
     */
    const FUNCTION_GET_MINIMUM_VOLTAGE = 39;

    /**
     * @internal
     */
    const FUNCTION_SET_TIME_BASE = 42;

    /**
     * @internal
     */
    const FUNCTION_GET_TIME_BASE = 43;

    /**
     * @internal
     */
    const FUNCTION_GET_ALL_DATA = 44;

    /**
     * @internal
     */
    const FUNCTION_SET_ALL_DATA_PERIOD = 45;

    /**
     * @internal
     */
    const FUNCTION_GET_ALL_DATA_PERIOD = 46;

    /**
     * @internal
     */
    const FUNCTION_GET_SEND_TIMEOUT_COUNT = 233;

    /**
     * @internal
     */
    const FUNCTION_ENABLE_STATUS_LED = 238;

    /**
     * @internal
     */
    const FUNCTION_DISABLE_STATUS_LED = 239;

    /**
     * @internal
     */
    const FUNCTION_IS_STATUS_LED_ENABLED = 240;

    /**
     * @internal
     */
    const FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241;

    /**
     * @internal
     */
    const FUNCTION_GET_CHIP_TEMPERATURE = 242;

    /**
     * @internal
     */
    const FUNCTION_RESET = 243;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const STEP_RESOLUTION_1 = 8;
    const STEP_RESOLUTION_2 = 7;
    const STEP_RESOLUTION_4 = 6;
    const STEP_RESOLUTION_8 = 5;
    const STEP_RESOLUTION_16 = 4;
    const STEP_RESOLUTION_32 = 3;
    const STEP_RESOLUTION_64 = 2;
    const STEP_RESOLUTION_128 = 1;
    const STEP_RESOLUTION_256 = 0;
    const CHOPPER_MODE_SPREAD_CYCLE = 0;
    const CHOPPER_MODE_FAST_DECAY = 1;
    const FREEWHEEL_MODE_NORMAL = 0;
    const FREEWHEEL_MODE_FREEWHEELING = 1;
    const FREEWHEEL_MODE_COIL_SHORT_LS = 2;
    const FREEWHEEL_MODE_COIL_SHORT_HS = 3;
    const CURRENT_UP_STEP_INCREMENT_1 = 0;
    const CURRENT_UP_STEP_INCREMENT_2 = 1;
    const CURRENT_UP_STEP_INCREMENT_4 = 2;
    const CURRENT_UP_STEP_INCREMENT_8 = 3;
    const CURRENT_DOWN_STEP_DECREMENT_1 = 0;
    const CURRENT_DOWN_STEP_DECREMENT_2 = 1;
    const CURRENT_DOWN_STEP_DECREMENT_8 = 2;
    const CURRENT_DOWN_STEP_DECREMENT_32 = 3;
    const MINIMUM_CURRENT_HALF = 0;
    const MINIMUM_CURRENT_QUARTER = 1;
    const STALLGUARD_MODE_STANDARD = 0;
    const STALLGUARD_MODE_FILTERED = 1;
    const OPEN_LOAD_NONE = 0;
    const OPEN_LOAD_PHASE_A = 1;
    const OPEN_LOAD_PHASE_B = 2;
    const OPEN_LOAD_PHASE_AB = 3;
    const SHORT_TO_GROUND_NONE = 0;
    const SHORT_TO_GROUND_PHASE_A = 1;
    const SHORT_TO_GROUND_PHASE_B = 2;
    const SHORT_TO_GROUND_PHASE_AB = 3;
    const OVER_TEMPERATURE_NONE = 0;
    const OVER_TEMPERATURE_WARNING = 1;
    const OVER_TEMPERATURE_LIMIT = 2;
    const STATE_STOP = 1;
    const STATE_ACCELERATION = 2;
    const STATE_RUN = 3;
    const STATE_DEACCELERATION = 4;
    const STATE_DIRECTION_CHANGE_TO_FORWARD = 5;
    const STATE_DIRECTION_CHANGE_TO_BACKWARD = 6;
    const COMMUNICATION_METHOD_NONE = 0;
    const COMMUNICATION_METHOD_USB = 1;
    const COMMUNICATION_METHOD_SPI_STACK = 2;
    const COMMUNICATION_METHOD_CHIBI = 3;
    const COMMUNICATION_METHOD_RS485 = 4;
    const COMMUNICATION_METHOD_WIFI = 5;
    const COMMUNICATION_METHOD_ETHERNET = 6;
    const COMMUNICATION_METHOD_WIFI_V2 = 7;

    const DEVICE_IDENTIFIER = 19;

    const DEVICE_DISPLAY_NAME = "Silent Stepper Brick";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_SET_MAX_VELOCITY] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_MAX_VELOCITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_CURRENT_VELOCITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_SPEED_RAMPING] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_SPEED_RAMPING] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_FULL_BRAKE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_SET_CURRENT_POSITION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_CURRENT_POSITION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_TARGET_POSITION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_TARGET_POSITION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_STEPS] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_STEPS] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_REMAINING_STEPS] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_STEP_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_STEP_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_DRIVE_FORWARD] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_DRIVE_BACKWARD] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_STOP] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_STACK_INPUT_VOLTAGE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_CURRENT_CONSUMPTION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_MOTOR_CURRENT] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_MOTOR_CURRENT] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_ENABLE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_DISABLE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_IS_ENABLED] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_BASIC_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_BASIC_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_SPREADCYCLE_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_SPREADCYCLE_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_STEALTH_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_STEALTH_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_COOLSTEP_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_COOLSTEP_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_MISC_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_MISC_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DRIVER_STATUS] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_MINIMUM_VOLTAGE] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_MINIMUM_VOLTAGE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_UNDER_VOLTAGE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_POSITION_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_SET_TIME_BASE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_TIME_BASE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ALL_DATA] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_ALL_DATA_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ALL_DATA_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_ALL_DATA] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_NEW_STATE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_SEND_TIMEOUT_COUNT] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_ENABLE_STATUS_LED] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_DISABLE_STATUS_LED] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_IS_STATUS_LED_ENABLED] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_CHIP_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_RESET] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_UNDER_VOLTAGE] = 'callbackWrapperUnderVoltage';
        $this->callbackWrappers[self::CALLBACK_POSITION_REACHED] = 'callbackWrapperPositionReached';
        $this->callbackWrappers[self::CALLBACK_ALL_DATA] = 'callbackWrapperAllData';
        $this->callbackWrappers[self::CALLBACK_NEW_STATE] = 'callbackWrapperNewState';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Sets the maximum velocity of the stepper motor in steps per second.
     * This function does *not* start the motor, it merely sets the maximum
     * velocity the stepper motor is accelerated to. To get the motor running use
     * either BrickSilentStepper::setTargetPosition(), BrickSilentStepper::setSteps(), BrickSilentStepper::driveForward() or
     * BrickSilentStepper::driveBackward().
     * 
     * @param int $velocity
     * 
     * @return void
     */
    public function setMaxVelocity($velocity)
    {
        $payload = '';
        $payload .= pack('v', $velocity);

        $this->sendRequest(self::FUNCTION_SET_MAX_VELOCITY, $payload);
    }

    /**
     * Returns the velocity as set by BrickSilentStepper::setMaxVelocity().
     * 
     * 
     * @return int
     */
    public function getMaxVelocity()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MAX_VELOCITY, $payload);

        $payload = unpack('v1velocity', $data);

        return $payload['velocity'];
    }

    /**
     * Returns the *current* velocity of the stepper motor in steps per second.
     * 
     * 
     * @return int
     */
    public function getCurrentVelocity()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CURRENT_VELOCITY, $payload);

        $payload = unpack('v1velocity', $data);

        return $payload['velocity'];
    }

    /**
     * Sets the acceleration and deacceleration of the stepper motor. The values
     * are given in *steps/s²*. An acceleration of 1000 means, that
     * every second the velocity is increased by 1000 *steps/s*.
     * 
     * For example: If the current velocity is 0 and you want to accelerate to a
     * velocity of 8000 *steps/s* in 10 seconds, you should set an acceleration
     * of 800 *steps/s²*.
     * 
     * An acceleration/deacceleration of 0 means instantaneous
     * acceleration/deacceleration (not recommended)
     * 
     * The default value is 1000 for both
     * 
     * @param int $acceleration
     * @param int $deacceleration
     * 
     * @return void
     */
    public function setSpeedRamping($acceleration, $deacceleration)
    {
        $payload = '';
        $payload .= pack('v', $acceleration);
        $payload .= pack('v', $deacceleration);

        $this->sendRequest(self::FUNCTION_SET_SPEED_RAMPING, $payload);
    }

    /**
     * Returns the acceleration and deacceleration as set by
     * BrickSilentStepper::setSpeedRamping().
     * 
     * 
     * @return array
     */
    public function getSpeedRamping()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_SPEED_RAMPING, $payload);

        $payload = unpack('v1acceleration/v1deacceleration', $data);

        $result['acceleration'] = $payload['acceleration'];
        $result['deacceleration'] = $payload['deacceleration'];

        return $result;
    }

    /**
     * Executes an active full brake.
     * 
     * <warning>
     *  This function is for emergency purposes,
     *  where an immediate brake is necessary. Depending on the current velocity and
     *  the strength of the motor, a full brake can be quite violent.
     * </warning>
     * 
     * Call BrickSilentStepper::stop() if you just want to stop the motor.
     * 
     * 
     * @return void
     */
    public function fullBrake()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_FULL_BRAKE, $payload);
    }

    /**
     * Sets the current steps of the internal step counter. This can be used to
     * set the current position to 0 when some kind of starting position
     * is reached (e.g. when a CNC machine reaches a corner).
     * 
     * @param int $position
     * 
     * @return void
     */
    public function setCurrentPosition($position)
    {
        $payload = '';
        $payload .= pack('V', $position);

        $this->sendRequest(self::FUNCTION_SET_CURRENT_POSITION, $payload);
    }

    /**
     * Returns the current position of the stepper motor in steps. On startup
     * the position is 0. The steps are counted with all possible driving
     * functions (BrickSilentStepper::setTargetPosition(), BrickSilentStepper::setSteps(), BrickSilentStepper::driveForward() or
     * BrickSilentStepper::driveBackward()). It also is possible to reset the steps to 0 or
     * set them to any other desired value with BrickSilentStepper::setCurrentPosition().
     * 
     * 
     * @return int
     */
    public function getCurrentPosition()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CURRENT_POSITION, $payload);

        $payload = unpack('V1position', $data);

        return IPConnection::fixUnpackedInt32($payload, 'position');
    }

    /**
     * Sets the target position of the stepper motor in steps. For example,
     * if the current position of the motor is 500 and BrickSilentStepper::setTargetPosition() is
     * called with 1000, the stepper motor will drive 500 steps forward. It will
     * use the velocity, acceleration and deacceleration as set by
     * BrickSilentStepper::setMaxVelocity() and BrickSilentStepper::setSpeedRamping().
     * 
     * A call of BrickSilentStepper::setTargetPosition() with the parameter *x* is equivalent to
     * a call of BrickSilentStepper::setSteps() with the parameter
     * (*x* - BrickSilentStepper::getCurrentPosition()).
     * 
     * @param int $position
     * 
     * @return void
     */
    public function setTargetPosition($position)
    {
        $payload = '';
        $payload .= pack('V', $position);

        $this->sendRequest(self::FUNCTION_SET_TARGET_POSITION, $payload);
    }

    /**
     * Returns the last target position as set by BrickSilentStepper::setTargetPosition().
     * 
     * 
     * @return int
     */
    public function getTargetPosition()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TARGET_POSITION, $payload);

        $payload = unpack('V1position', $data);

        return IPConnection::fixUnpackedInt32($payload, 'position');
    }

    /**
     * Sets the number of steps the stepper motor should run. Positive values
     * will drive the motor forward and negative values backward.
     * The velocity, acceleration and deacceleration as set by
     * BrickSilentStepper::setMaxVelocity() and BrickSilentStepper::setSpeedRamping() will be used.
     * 
     * @param int $steps
     * 
     * @return void
     */
    public function setSteps($steps)
    {
        $payload = '';
        $payload .= pack('V', $steps);

        $this->sendRequest(self::FUNCTION_SET_STEPS, $payload);
    }

    /**
     * Returns the last steps as set by BrickSilentStepper::setSteps().
     * 
     * 
     * @return int
     */
    public function getSteps()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_STEPS, $payload);

        $payload = unpack('V1steps', $data);

        return IPConnection::fixUnpackedInt32($payload, 'steps');
    }

    /**
     * Returns the remaining steps of the last call of BrickSilentStepper::setSteps().
     * For example, if BrickSilentStepper::setSteps() is called with 2000 and
     * BrickSilentStepper::getRemainingSteps() is called after the motor has run for 500 steps,
     * it will return 1500.
     * 
     * 
     * @return int
     */
    public function getRemainingSteps()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_REMAINING_STEPS, $payload);

        $payload = unpack('V1steps', $data);

        return IPConnection::fixUnpackedInt32($payload, 'steps');
    }

    /**
     * Sets the step resolution from full-step up to 1/256-step.
     * 
     * If interpolation is turned on, the Silent Stepper Brick will always interpolate
     * your step inputs as 1/256-step. If you use full-step mode with interpolation, each
     * step will generate 256 1/256 steps.
     * 
     * For maximum torque use full-step without interpolation. For maximum resolution use
     * 1/256-step. Turn interpolation on to make the Stepper driving less noisy.
     * 
     * If you often change the speed with high acceleration you should turn the
     * interpolation off.
     * 
     * The default is 1/256-step with interpolation on.
     * 
     * @param int $step_resolution
     * @param bool $interpolation
     * 
     * @return void
     */
    public function setStepConfiguration($step_resolution, $interpolation)
    {
        $payload = '';
        $payload .= pack('C', $step_resolution);
        $payload .= pack('C', intval((bool)$interpolation));

        $this->sendRequest(self::FUNCTION_SET_STEP_CONFIGURATION, $payload);
    }

    /**
     * Returns the step mode as set by BrickSilentStepper::setStepConfiguration().
     * 
     * 
     * @return array
     */
    public function getStepConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_STEP_CONFIGURATION, $payload);

        $payload = unpack('C1step_resolution/C1interpolation', $data);

        $result['step_resolution'] = $payload['step_resolution'];
        $result['interpolation'] = (bool)$payload['interpolation'];

        return $result;
    }

    /**
     * Drives the stepper motor forward until BrickSilentStepper::driveBackward() or
     * BrickSilentStepper::stop() is called. The velocity, acceleration and deacceleration as
     * set by BrickSilentStepper::setMaxVelocity() and BrickSilentStepper::setSpeedRamping() will be used.
     * 
     * 
     * @return void
     */
    public function driveForward()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DRIVE_FORWARD, $payload);
    }

    /**
     * Drives the stepper motor backward until BrickSilentStepper::driveForward() or
     * BrickSilentStepper::stop() is triggered. The velocity, acceleration and deacceleration as
     * set by BrickSilentStepper::setMaxVelocity() and BrickSilentStepper::setSpeedRamping() will be used.
     * 
     * 
     * @return void
     */
    public function driveBackward()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DRIVE_BACKWARD, $payload);
    }

    /**
     * Stops the stepper motor with the deacceleration as set by
     * BrickSilentStepper::setSpeedRamping().
     * 
     * 
     * @return void
     */
    public function stop()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_STOP, $payload);
    }

    /**
     * Returns the stack input voltage in mV. The stack input voltage is the
     * voltage that is supplied via the stack, i.e. it is given by a
     * Step-Down or Step-Up Power Supply.
     * 
     * 
     * @return int
     */
    public function getStackInputVoltage()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_STACK_INPUT_VOLTAGE, $payload);

        $payload = unpack('v1voltage', $data);

        return $payload['voltage'];
    }

    /**
     * Returns the external input voltage in mV. The external input voltage is
     * given via the black power input connector on the Slient Stepper Brick.
     * 
     * If there is an external input voltage and a stack input voltage, the motor
     * will be driven by the external input voltage. If there is only a stack
     * voltage present, the motor will be driven by this voltage.
     * 
     * <warning>
     *  This means, if you have a high stack voltage and a low external voltage,
     *  the motor will be driven with the low external voltage. If you then remove
     *  the external connection, it will immediately be driven by the high
     *  stack voltage
     * </warning>
     * 
     * 
     * @return int
     */
    public function getExternalInputVoltage()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, $payload);

        $payload = unpack('v1voltage', $data);

        return $payload['voltage'];
    }

    /**
     * Returns the current consumption of the motor in mA.
     * 
     * 
     * @return int
     */
    public function getCurrentConsumption()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CURRENT_CONSUMPTION, $payload);

        $payload = unpack('v1current', $data);

        return $payload['current'];
    }

    /**
     * Sets the current in mA with which the motor will be driven.
     * The minimum value is 360mA, the maximum value 1640mA and the
     * default value is 800mA.
     * 
     * <warning>
     *  Do not set this value above the specifications of your stepper motor.
     *  Otherwise it may damage your motor.
     * </warning>
     * 
     * @param int $current
     * 
     * @return void
     */
    public function setMotorCurrent($current)
    {
        $payload = '';
        $payload .= pack('v', $current);

        $this->sendRequest(self::FUNCTION_SET_MOTOR_CURRENT, $payload);
    }

    /**
     * Returns the current as set by BrickSilentStepper::setMotorCurrent().
     * 
     * 
     * @return int
     */
    public function getMotorCurrent()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MOTOR_CURRENT, $payload);

        $payload = unpack('v1current', $data);

        return $payload['current'];
    }

    /**
     * Enables the driver chip. The driver parameters can be configured (maximum velocity,
     * acceleration, etc) before it is enabled.
     * 
     * 
     * @return void
     */
    public function enable()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_ENABLE, $payload);
    }

    /**
     * Disables the driver chip. The configurations are kept (maximum velocity,
     * acceleration, etc) but the motor is not driven until it is enabled again.
     * 
     * 
     * @return void
     */
    public function disable()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DISABLE, $payload);
    }

    /**
     * Returns *true* if the driver chip is enabled, *false* otherwise.
     * 
     * 
     * @return bool
     */
    public function isEnabled()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_IS_ENABLED, $payload);

        $payload = unpack('C1enabled', $data);

        return (bool)$payload['enabled'];
    }

    /**
     * Sets the basic configuration parameters for the different modes (Stealth, Coolstep, Classic).
     * 
     * * Standstill Current: This value can be used to lower the current during stand still. This might
     *   be reasonable to reduce the heating of the motor and the Brick. When the motor is in standstill 
     *   the configured motor phase current will be driven until the configured 
     *   Power Down Time is elapsed. After that the phase current will be reduced to the standstill 
     *   current. The elapsed time for this reduction can be configured with the Standstill Delay Time.
     *   The unit is in mA and the maximum allowed value is the configured maximum motor current
     *   (see BrickSilentStepper::setMotorCurrent()).
     * 
     * * Motor Run Current: The value sets the motor current when the motor is running. 
     *   Use a value of at least one half of the global maximum motor current for a good 
     *   microstep performance. The unit is in mA and the maximum allowed value is the current 
     *   motor current. The API maps the entered value to 1/32 ... 32/32 of the maximum
     *   motor current. This value should be used to change the motor current during motor movement,
     *   whereas the global maximum motor current should not be changed while the motor is moving
     *   (see BrickSilentStepper::setMotorCurrent()).
     * 
     * * Standstill Delay Time: Controls the duration for motor power down after a motion
     *   as soon as standstill is detected and the Power Down Time is expired. A high Standstill Delay
     *   Time results in a smooth transition that avoids motor jerk during power down.
     *   The value range is 0 to 307ms
     * 
     * * Power Down Time: Sets the delay time after a stand still.
     *   The value range is 0 to 5222ms.
     * 
     * * Stealth Threshold: Sets the upper threshold for Stealth mode in steps/s. The value range is
     *   0-65536 steps/s. If the velocity of the motor goes above this value, Stealth mode is turned
     *   off. Otherwise it is turned on. In Stealth mode the torque declines with high speed.
     * 
     * * Coolstep Threshold: Sets the lower threshold for Coolstep mode in steps/s. The value range is
     *   0-65536 steps/s. The Coolstep Threshold needs to be above the Stealth Threshold.
     * 
     * * Classic Threshold: Sets the lower threshold for classic mode. The value range is
     *   0-65536 steps/s. In classic mode the stepper becomes more noisy, but the torque is maximized.
     * 
     * * High Velocity Shopper Mode: If High Velocity Shopper Mode is enabled, the stepper control
     *   is optimized to run the stepper motors at high velocities.
     * 
     * If you want to use all three thresholds make sure that
     * Stealth Threshold < Coolstep Threshold < Classic Threshold.
     * 
     * The default values are:
     * 
     * * Standstill Current: 200
     * * Motor Run Current: 800
     * * Standstill Delay Time: 0
     * * Power Down Time: 1000
     * * Stealth Threshold: 500
     * * Coolstep Threshold: 500
     * * Classic Threshold: 1000
     * * High Velocity Shopper Mode: false
     * 
     * @param int $standstill_current
     * @param int $motor_run_current
     * @param int $standstill_delay_time
     * @param int $power_down_time
     * @param int $stealth_threshold
     * @param int $coolstep_threshold
     * @param int $classic_threshold
     * @param bool $high_velocity_chopper_mode
     * 
     * @return void
     */
    public function setBasicConfiguration($standstill_current, $motor_run_current, $standstill_delay_time, $power_down_time, $stealth_threshold, $coolstep_threshold, $classic_threshold, $high_velocity_chopper_mode)
    {
        $payload = '';
        $payload .= pack('v', $standstill_current);
        $payload .= pack('v', $motor_run_current);
        $payload .= pack('v', $standstill_delay_time);
        $payload .= pack('v', $power_down_time);
        $payload .= pack('v', $stealth_threshold);
        $payload .= pack('v', $coolstep_threshold);
        $payload .= pack('v', $classic_threshold);
        $payload .= pack('C', intval((bool)$high_velocity_chopper_mode));

        $this->sendRequest(self::FUNCTION_SET_BASIC_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickSilentStepper::setBasicConfiguration().
     * 
     * 
     * @return array
     */
    public function getBasicConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_BASIC_CONFIGURATION, $payload);

        $payload = unpack('v1standstill_current/v1motor_run_current/v1standstill_delay_time/v1power_down_time/v1stealth_threshold/v1coolstep_threshold/v1classic_threshold/C1high_velocity_chopper_mode', $data);

        $result['standstill_current'] = $payload['standstill_current'];
        $result['motor_run_current'] = $payload['motor_run_current'];
        $result['standstill_delay_time'] = $payload['standstill_delay_time'];
        $result['power_down_time'] = $payload['power_down_time'];
        $result['stealth_threshold'] = $payload['stealth_threshold'];
        $result['coolstep_threshold'] = $payload['coolstep_threshold'];
        $result['classic_threshold'] = $payload['classic_threshold'];
        $result['high_velocity_chopper_mode'] = (bool)$payload['high_velocity_chopper_mode'];

        return $result;
    }

    /**
     * Note: If you don't know what any of this means you can very likely keep all of
     * the values as default!
     * 
     * Sets the Spreadcycle configuration parameters. Spreadcycle is a chopper algorithm which actively
     * controls the motor current flow. More information can be found in the TMC2130 datasheet on page
     * 47 (7 spreadCycle and Classic Chopper).
     * 
     * * Slow Decay Duration: Controls duration of off time setting of slow decay phase. The value
     *   range is 0-15. 0 = driver disabled, all bridges off. Use 1 only with Comparator Blank time >= 2.
     * 
     * * Enable Random Slow Decay: Set to false to fix chopper off time as set by Slow Decay Duration.
     *   If you set it to true, Decay Duration is randomly modulated.
     * 
     * * Fast Decay Duration: Sets the fast decay duration. The value range is 0-15. This parameters is
     *   only used if the Chopper Mode is set to Fast Decay.
     * 
     * * Hysteresis Start Value: Sets the hysteresis start value. The value range is 0-7. This parameter is
     *   only used if the Chopper Mode is set to Spread Cycle.
     * 
     * * Hysteresis End Value: Sets the hysteresis end value. The value range is -3 to 12. This parameter is
     *   only used if the Chopper Mode is set to Spread Cycle.
     * 
     * * Sine Wave Offset: Sets the sine wave offset. The value range is -3 to 12. This parameters is
     *   only used if the Chopper Mode is set to Fast Decay. 1/512 of the value becomes added to the absolute
     *   value of the sine wave.
     * 
     * * Chopper Mode: 0 = Spread Cycle, 1 = Fast Decay.
     * 
     * * Comparator Blank Time: Sets the blank time of the comparator. Available values are
     * 
     *   * 0 = 16 clocks,
     *   * 1 = 24 clocks,
     *   * 2 = 36 clocks and
     *   * 3 = 54 clocks.
     * 
     *   A value of 1 or 2 is recommended for most applications.
     * 
     * * Fast Decay Without Comparator: If set to true the current comparator usage for termination of the
     *   fast decay cycle is disabled.
     * 
     * The default values are:
     * 
     * * Slow Decay Duration: 4
     * * Enable Random Slow Decay: 0
     * * Fast Decay Duration: 0
     * * Hysteresis Start Value: 0
     * * Hysteresis End Value: 0
     * * Sine Wave Offset: 0
     * * Chopper Mode: 0
     * * Comparator Blank Time: 1
     * * Fast Decay Without Comparator: false
     * 
     * @param int $slow_decay_duration
     * @param bool $enable_random_slow_decay
     * @param int $fast_decay_duration
     * @param int $hysteresis_start_value
     * @param int $hysteresis_end_value
     * @param int $sine_wave_offset
     * @param int $chopper_mode
     * @param int $comparator_blank_time
     * @param bool $fast_decay_without_comparator
     * 
     * @return void
     */
    public function setSpreadcycleConfiguration($slow_decay_duration, $enable_random_slow_decay, $fast_decay_duration, $hysteresis_start_value, $hysteresis_end_value, $sine_wave_offset, $chopper_mode, $comparator_blank_time, $fast_decay_without_comparator)
    {
        $payload = '';
        $payload .= pack('C', $slow_decay_duration);
        $payload .= pack('C', intval((bool)$enable_random_slow_decay));
        $payload .= pack('C', $fast_decay_duration);
        $payload .= pack('C', $hysteresis_start_value);
        $payload .= pack('c', $hysteresis_end_value);
        $payload .= pack('c', $sine_wave_offset);
        $payload .= pack('C', $chopper_mode);
        $payload .= pack('C', $comparator_blank_time);
        $payload .= pack('C', intval((bool)$fast_decay_without_comparator));

        $this->sendRequest(self::FUNCTION_SET_SPREADCYCLE_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickSilentStepper::setBasicConfiguration().
     * 
     * 
     * @return array
     */
    public function getSpreadcycleConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_SPREADCYCLE_CONFIGURATION, $payload);

        $payload = unpack('C1slow_decay_duration/C1enable_random_slow_decay/C1fast_decay_duration/C1hysteresis_start_value/c1hysteresis_end_value/c1sine_wave_offset/C1chopper_mode/C1comparator_blank_time/C1fast_decay_without_comparator', $data);

        $result['slow_decay_duration'] = $payload['slow_decay_duration'];
        $result['enable_random_slow_decay'] = (bool)$payload['enable_random_slow_decay'];
        $result['fast_decay_duration'] = $payload['fast_decay_duration'];
        $result['hysteresis_start_value'] = $payload['hysteresis_start_value'];
        $result['hysteresis_end_value'] = $payload['hysteresis_end_value'];
        $result['sine_wave_offset'] = $payload['sine_wave_offset'];
        $result['chopper_mode'] = $payload['chopper_mode'];
        $result['comparator_blank_time'] = $payload['comparator_blank_time'];
        $result['fast_decay_without_comparator'] = (bool)$payload['fast_decay_without_comparator'];

        return $result;
    }

    /**
     * Note: If you don't know what any of this means you can very likely keep all of
     * the values as default!
     * 
     * Sets the configuration relevant for Stealth mode.
     * 
     * * Enable Stealth: If set to true the stealth mode is enabled, if set to false the
     *   stealth mode is disabled, even if the speed is below the threshold set in BrickSilentStepper::setBasicConfiguration().
     * 
     * * Amplitude: If autoscale is disabled, the PWM amplitude is scaled by this value. If autoscale is enabled,
     *   this value defines the maximum PWM amplitude change per half wave. The value range is 0-255.
     * 
     * * Gradient: If autoscale is disabled, the PWM gradient is scaled by this value. If autoscale is enabled,
     *   this value defines the maximum PWM gradient. With autoscale a value above 64 is recommended,
     *   otherwise the regulation might not be able to measure the current. The value range is 0-255.
     * 
     * * Enable Autoscale: If set to true, automatic current control is used. Otherwise the user defined
     *   amplitude and gradient are used.
     * 
     * * Force Symmetric: If true, A symmetric PWM cycle is enforced. Otherwise the PWM value may change within each
     *   PWM cycle.
     * 
     * * Freewheel Mode: The freewheel mode defines the behavior in stand still if the Standstill Current
     *   (see BrickSilentStepper::setBasicConfiguration()) is set to 0.
     * 
     * The default values are:
     * 
     * * Enable Stealth: true
     * * Amplitude: 128
     * * Gradient: 4
     * * Enable Autoscale: true
     * * Force Symmetric: false
     * * Freewheel Mode: 0 (Normal)
     * 
     * @param bool $enable_stealth
     * @param int $amplitude
     * @param int $gradient
     * @param bool $enable_autoscale
     * @param bool $force_symmetric
     * @param int $freewheel_mode
     * 
     * @return void
     */
    public function setStealthConfiguration($enable_stealth, $amplitude, $gradient, $enable_autoscale, $force_symmetric, $freewheel_mode)
    {
        $payload = '';
        $payload .= pack('C', intval((bool)$enable_stealth));
        $payload .= pack('C', $amplitude);
        $payload .= pack('C', $gradient);
        $payload .= pack('C', intval((bool)$enable_autoscale));
        $payload .= pack('C', intval((bool)$force_symmetric));
        $payload .= pack('C', $freewheel_mode);

        $this->sendRequest(self::FUNCTION_SET_STEALTH_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickSilentStepper::setStealthConfiguration().
     * 
     * 
     * @return array
     */
    public function getStealthConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_STEALTH_CONFIGURATION, $payload);

        $payload = unpack('C1enable_stealth/C1amplitude/C1gradient/C1enable_autoscale/C1force_symmetric/C1freewheel_mode', $data);

        $result['enable_stealth'] = (bool)$payload['enable_stealth'];
        $result['amplitude'] = $payload['amplitude'];
        $result['gradient'] = $payload['gradient'];
        $result['enable_autoscale'] = (bool)$payload['enable_autoscale'];
        $result['force_symmetric'] = (bool)$payload['force_symmetric'];
        $result['freewheel_mode'] = $payload['freewheel_mode'];

        return $result;
    }

    /**
     * Note: If you don't know what any of this means you can very likely keep all of
     * the values as default!
     * 
     * Sets the configuration relevant for Coolstep.
     * 
     * * Minimum Stallguard Value: If the Stallguard result falls below this value*32, the motor current
     *   is increased to reduce motor load angle. The value range is 0-15. A value of 0 turns Coolstep off.
     * 
     * * Maximum Stallguard Value: If the Stallguard result goes above
     *   (Min Stallguard Value + Max Stallguard Value + 1) * 32, the motor current is decreased to save
     *   energy.
     * 
     * * Current Up Step Width: Sets the up step increment per Stallguard value. The value range is 0-3,
     *   corresponding to the increments 1, 2, 4 and 8.
     * 
     * * Current Down Step Width: Sets the down step decrement per Stallguard value. The value range is 0-3,
     *   corresponding to the decrements 1, 2, 8 and 16.
     * 
     * * Minimum Current: Sets the minimum current for Coolstep current control. You can choose between
     *   half and quarter of the run current.
     * 
     * * Stallguard Threshold Value: Sets the level for stall output (see BrickSilentStepper::getDriverStatus()). The value
     *   range is -64 to +63. A lower value gives a higher sensitivity. You have to find a suitable value for your
     *   motor by trial and error, 0 works for most motors.
     * 
     * * Stallguard Mode: Set to 0 for standard resolution or 1 for filtered mode. In filtered mode the Stallguard
     *   signal will be updated every four full-steps.
     * 
     * The default values are:
     * 
     * * Minimum Stallguard Value: 2
     * * Maximum Stallguard Value: 10
     * * Current Up Step Width: 0
     * * Current Down Step Width: 0
     * * Minimum Current: 0
     * * Stallguard Threshold Value: 0
     * * Stallguard Mode: 0
     * 
     * @param int $minimum_stallguard_value
     * @param int $maximum_stallguard_value
     * @param int $current_up_step_width
     * @param int $current_down_step_width
     * @param int $minimum_current
     * @param int $stallguard_threshold_value
     * @param int $stallguard_mode
     * 
     * @return void
     */
    public function setCoolstepConfiguration($minimum_stallguard_value, $maximum_stallguard_value, $current_up_step_width, $current_down_step_width, $minimum_current, $stallguard_threshold_value, $stallguard_mode)
    {
        $payload = '';
        $payload .= pack('C', $minimum_stallguard_value);
        $payload .= pack('C', $maximum_stallguard_value);
        $payload .= pack('C', $current_up_step_width);
        $payload .= pack('C', $current_down_step_width);
        $payload .= pack('C', $minimum_current);
        $payload .= pack('c', $stallguard_threshold_value);
        $payload .= pack('C', $stallguard_mode);

        $this->sendRequest(self::FUNCTION_SET_COOLSTEP_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickSilentStepper::setCoolstepConfiguration().
     * 
     * 
     * @return array
     */
    public function getCoolstepConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_COOLSTEP_CONFIGURATION, $payload);

        $payload = unpack('C1minimum_stallguard_value/C1maximum_stallguard_value/C1current_up_step_width/C1current_down_step_width/C1minimum_current/c1stallguard_threshold_value/C1stallguard_mode', $data);

        $result['minimum_stallguard_value'] = $payload['minimum_stallguard_value'];
        $result['maximum_stallguard_value'] = $payload['maximum_stallguard_value'];
        $result['current_up_step_width'] = $payload['current_up_step_width'];
        $result['current_down_step_width'] = $payload['current_down_step_width'];
        $result['minimum_current'] = $payload['minimum_current'];
        $result['stallguard_threshold_value'] = $payload['stallguard_threshold_value'];
        $result['stallguard_mode'] = $payload['stallguard_mode'];

        return $result;
    }

    /**
     * Note: If you don't know what any of this means you can very likely keep all of
     * the values as default!
     * 
     * Sets miscellaneous configuration parameters.
     * 
     * * Disable Short To Ground Protection: Set to false to enable short to ground protection, otherwise
     *   it is disabled.
     * 
     * * Synchronize Phase Frequency: With this parameter you can synchronize the chopper for both phases
     *   of a two phase motor to avoid the occurrence of a beat. The value range is 0-15. If set to 0,
     *   the synchronization is turned off. Otherwise the synchronization is done through the formula
     *   f_sync = f_clk/(value*64). In Classic Mode the synchronization is automatically switched off.
     *   f_clk is 12.8MHz.
     * 
     * The default values are:
     * 
     * * Disable Short To Ground Protection: 0
     * * Synchronize Phase Frequency: 0
     * 
     * @param bool $disable_short_to_ground_protection
     * @param int $synchronize_phase_frequency
     * 
     * @return void
     */
    public function setMiscConfiguration($disable_short_to_ground_protection, $synchronize_phase_frequency)
    {
        $payload = '';
        $payload .= pack('C', intval((bool)$disable_short_to_ground_protection));
        $payload .= pack('C', $synchronize_phase_frequency);

        $this->sendRequest(self::FUNCTION_SET_MISC_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickSilentStepper::setMiscConfiguration().
     * 
     * 
     * @return array
     */
    public function getMiscConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MISC_CONFIGURATION, $payload);

        $payload = unpack('C1disable_short_to_ground_protection/C1synchronize_phase_frequency', $data);

        $result['disable_short_to_ground_protection'] = (bool)$payload['disable_short_to_ground_protection'];
        $result['synchronize_phase_frequency'] = $payload['synchronize_phase_frequency'];

        return $result;
    }

    /**
     * Returns the current driver status.
     * 
     * * Open Load: Indicates if an open load is present on phase A, B or both. This could mean that there is a problem
     *   with the wiring of the motor. False detection can occur in fast motion as well as during stand still.
     * 
     * * Short To Ground: Indicates if a short to ground is present on phase A, B or both. If this is detected the driver
     *   automatically becomes disabled and stays disabled until it is enabled again manually.
     * 
     * * Over Temperature: The over temperature indicator switches to "Warning" if the driver IC warms up. The warning flag
     *   is expected during long duration stepper uses. If the temperature limit is reached the indicator switches
     *   to "Limit". In this case the driver becomes disabled until it cools down again.
     * 
     * * Motor Stalled: Is true if a motor stall was detected.
     * 
     * * Actual Motor Current: Indicates the actual current control scaling as used in Coolstep mode.
     * 
     * * Stallguard Result: Indicates the load of the motor. A lower value signals a higher load. Per trial and error
     *   you can find out which value corresponds to a suitable torque for the velocity used in your application.
     *   After that you can use this threshold value to find out if a motor stall becomes probable and react on it (e.g.
     *   decrease velocity).
     *   During stand still this value can not be used for stall detection, it shows the chopper on-time for motor coil A.
     * 
     * * Stealth Voltage Amplitude: Shows the actual PWM scaling. In Stealth mode it can be used to detect motor load and
     *   stall if autoscale is enabled (see BrickSilentStepper::setStealthConfiguration()).
     * 
     * 
     * @return array
     */
    public function getDriverStatus()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DRIVER_STATUS, $payload);

        $payload = unpack('C1open_load/C1short_to_ground/C1over_temperature/C1motor_stalled/C1actual_motor_current/C1full_step_active/C1stallguard_result/C1stealth_voltage_amplitude', $data);

        $result['open_load'] = $payload['open_load'];
        $result['short_to_ground'] = $payload['short_to_ground'];
        $result['over_temperature'] = $payload['over_temperature'];
        $result['motor_stalled'] = (bool)$payload['motor_stalled'];
        $result['actual_motor_current'] = $payload['actual_motor_current'];
        $result['full_step_active'] = (bool)$payload['full_step_active'];
        $result['stallguard_result'] = $payload['stallguard_result'];
        $result['stealth_voltage_amplitude'] = $payload['stealth_voltage_amplitude'];

        return $result;
    }

    /**
     * Sets the minimum voltage in mV, below which the BrickSilentStepper::CALLBACK_UNDER_VOLTAGE callback
     * is triggered. The minimum possible value that works with the Slient Stepper
     * Brick is 8V.
     * You can use this function to detect the discharge of a battery that is used
     * to drive the stepper motor. If you have a fixed power supply, you likely do
     * not need this functionality.
     * 
     * The default value is 8V.
     * 
     * @param int $voltage
     * 
     * @return void
     */
    public function setMinimumVoltage($voltage)
    {
        $payload = '';
        $payload .= pack('v', $voltage);

        $this->sendRequest(self::FUNCTION_SET_MINIMUM_VOLTAGE, $payload);
    }

    /**
     * Returns the minimum voltage as set by BrickSilentStepper::setMinimumVoltage().
     * 
     * 
     * @return int
     */
    public function getMinimumVoltage()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MINIMUM_VOLTAGE, $payload);

        $payload = unpack('v1voltage', $data);

        return $payload['voltage'];
    }

    /**
     * Sets the time base of the velocity and the acceleration of the Silent Stepper
     * Brick (in seconds).
     * 
     * For example, if you want to make one step every 1.5 seconds, you can set
     * the time base to 15 and the velocity to 10. Now the velocity is
     * 10steps/15s = 1steps/1.5s.
     * 
     * The default value is 1.
     * 
     * @param int $time_base
     * 
     * @return void
     */
    public function setTimeBase($time_base)
    {
        $payload = '';
        $payload .= pack('V', $time_base);

        $this->sendRequest(self::FUNCTION_SET_TIME_BASE, $payload);
    }

    /**
     * Returns the time base as set by BrickSilentStepper::setTimeBase().
     * 
     * 
     * @return int
     */
    public function getTimeBase()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TIME_BASE, $payload);

        $payload = unpack('V1time_base', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'time_base');
    }

    /**
     * Returns the following parameters: The current velocity,
     * the current position, the remaining steps, the stack voltage, the external
     * voltage and the current consumption of the stepper motor.
     * 
     * There is also a callback for this function, see BrickSilentStepper::CALLBACK_ALL_DATA callback.
     * 
     * 
     * @return array
     */
    public function getAllData()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ALL_DATA, $payload);

        $payload = unpack('v1current_velocity/V1current_position/V1remaining_steps/v1stack_voltage/v1external_voltage/v1current_consumption', $data);

        $result['current_velocity'] = $payload['current_velocity'];
        $result['current_position'] = IPConnection::fixUnpackedInt32($payload, 'current_position');
        $result['remaining_steps'] = IPConnection::fixUnpackedInt32($payload, 'remaining_steps');
        $result['stack_voltage'] = $payload['stack_voltage'];
        $result['external_voltage'] = $payload['external_voltage'];
        $result['current_consumption'] = $payload['current_consumption'];

        return $result;
    }

    /**
     * Sets the period in ms with which the BrickSilentStepper::CALLBACK_ALL_DATA callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setAllDataPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_ALL_DATA_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickSilentStepper::setAllDataPeriod().
     * 
     * 
     * @return int
     */
    public function getAllDataPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ALL_DATA_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Returns the timeout count for the different communication methods.
     * 
     * The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
     * 
     * This function is mostly used for debugging during development, in normal operation
     * the counters should nearly always stay at 0.
     * 
     * @param int $communication_method
     * 
     * @return int
     */
    public function getSendTimeoutCount($communication_method)
    {
        $payload = '';
        $payload .= pack('C', $communication_method);

        $data = $this->sendRequest(self::FUNCTION_GET_SEND_TIMEOUT_COUNT, $payload);

        $payload = unpack('V1timeout_count', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'timeout_count');
    }

    /**
     * Enables the status LED.
     * 
     * The status LED is the blue LED next to the USB connector. If enabled is is
     * on and it flickers if data is transfered. If disabled it is always off.
     * 
     * The default state is enabled.
     * 
     * 
     * @return void
     */
    public function enableStatusLED()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_ENABLE_STATUS_LED, $payload);
    }

    /**
     * Disables the status LED.
     * 
     * The status LED is the blue LED next to the USB connector. If enabled is is
     * on and it flickers if data is transfered. If disabled it is always off.
     * 
     * The default state is enabled.
     * 
     * 
     * @return void
     */
    public function disableStatusLED()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DISABLE_STATUS_LED, $payload);
    }

    /**
     * Returns *true* if the status LED is enabled, *false* otherwise.
     * 
     * 
     * @return bool
     */
    public function isStatusLEDEnabled()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_IS_STATUS_LED_ENABLED, $payload);

        $payload = unpack('C1enabled', $data);

        return (bool)$payload['enabled'];
    }

    /**
     * Returns the firmware and protocol version and the name of the Bricklet for a
     * given port.
     * 
     * This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
     * plugins.
     * 
     * @param string $port
     * 
     * @return array
     */
    public function getProtocol1BrickletName($port)
    {
        $result = array();

        $payload = '';
        $payload .= pack('c', ord($port));

        $data = $this->sendRequest(self::FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, $payload);

        $payload = unpack('C1protocol_version/C3firmware_version/c40name', $data);

        $result['protocol_version'] = $payload['protocol_version'];
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['name'] = IPConnection::implodeUnpackedString($payload, 'name', 40);

        return $result;
    }

    /**
     * Returns the temperature in °C/10 as measured inside the microcontroller. The
     * value returned is not the ambient temperature!
     * 
     * The temperature is only proportional to the real temperature and it has an
     * accuracy of +-15%. Practically it is only useful as an indicator for
     * temperature changes.
     * 
     * 
     * @return int
     */
    public function getChipTemperature()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CHIP_TEMPERATURE, $payload);

        $payload = unpack('v1temperature', $data);

        return IPConnection::fixUnpackedInt16($payload, 'temperature');
    }

    /**
     * Calling this function will reset the Brick. Calling this function
     * on a Brick inside of a stack will reset the whole stack.
     * 
     * After a reset you have to create new device objects,
     * calling functions on the existing ones will result in
     * undefined behavior!
     * 
     * 
     * @return void
     */
    public function reset()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_RESET, $payload);
    }

    /**
     * Returns the UID, the UID where the Brick is connected to,
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be '0'-'8' (stack position).
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperUnderVoltage($data)
    {
        $result = array();
        $payload = unpack('v1voltage', $data);

        array_push($result, $payload['voltage']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_UNDER_VOLTAGE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_UNDER_VOLTAGE], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperPositionReached($data)
    {
        $result = array();
        $payload = unpack('V1position', $data);

        array_push($result, IPConnection::fixUnpackedInt32($payload, 'position'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_POSITION_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_POSITION_REACHED], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperAllData($data)
    {
        $result = array();
        $payload = unpack('v1current_velocity/V1current_position/V1remaining_steps/v1stack_voltage/v1external_voltage/v1current_consumption', $data);

        array_push($result, $payload['current_velocity']);
        array_push($result, IPConnection::fixUnpackedInt32($payload, 'current_position'));
        array_push($result, IPConnection::fixUnpackedInt32($payload, 'remaining_steps'));
        array_push($result, $payload['stack_voltage']);
        array_push($result, $payload['external_voltage']);
        array_push($result, $payload['current_consumption']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ALL_DATA]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ALL_DATA], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperNewState($data)
    {
        $result = array();
        $payload = unpack('C1state_new/C1state_previous', $data);

        array_push($result, $payload['state_new']);
        array_push($result, $payload['state_previous']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_NEW_STATE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_NEW_STATE], $result);
    }
}

?>
